// Code generated by easyjson for marshaling/unmarshaling. DO NOT EDIT.

package cdc

import (
	json "encoding/json"
	easyjson "github.com/mailru/easyjson"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
)

// suppress unused package warning
var (
	_ *json.RawMessage
	_ *jlexer.Lexer
	_ *jwriter.Writer
	_ easyjson.Marshaler
)

func easyjson4086215fDecodeGitlabComMiatelGoUtilsDatabaseCdc(in *jlexer.Lexer, out *Message) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeFieldName(false)
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "operation":
			if data := in.UnsafeBytes(); in.Ok() {
				in.AddError((out.Operation).UnmarshalText(data))
			}
		case "schema":
			out.Schema = string(in.String())
		case "table":
			out.Table = string(in.String())
		case "before":
			if in.IsNull() {
				in.Skip()
				out.Before = nil
			} else {
				if out.Before == nil {
					out.Before = new(Tuple)
				}
				if in.IsNull() {
					in.Skip()
				} else {
					in.Delim('{')
					if !in.IsDelim('}') {
						*out.Before = make(Tuple)
					} else {
						*out.Before = nil
					}
					for !in.IsDelim('}') {
						key := string(in.String())
						in.WantColon()
						var v1 interface{}
						if m, ok := v1.(easyjson.Unmarshaler); ok {
							m.UnmarshalEasyJSON(in)
						} else if m, ok := v1.(json.Unmarshaler); ok {
							_ = m.UnmarshalJSON(in.Raw())
						} else {
							v1 = in.Interface()
						}
						(*out.Before)[key] = v1
						in.WantComma()
					}
					in.Delim('}')
				}
			}
		case "after":
			if in.IsNull() {
				in.Skip()
				out.After = nil
			} else {
				if out.After == nil {
					out.After = new(Tuple)
				}
				if in.IsNull() {
					in.Skip()
				} else {
					in.Delim('{')
					if !in.IsDelim('}') {
						*out.After = make(Tuple)
					} else {
						*out.After = nil
					}
					for !in.IsDelim('}') {
						key := string(in.String())
						in.WantColon()
						var v2 interface{}
						if m, ok := v2.(easyjson.Unmarshaler); ok {
							m.UnmarshalEasyJSON(in)
						} else if m, ok := v2.(json.Unmarshaler); ok {
							_ = m.UnmarshalJSON(in.Raw())
						} else {
							v2 = in.Interface()
						}
						(*out.After)[key] = v2
						in.WantComma()
					}
					in.Delim('}')
				}
			}
		case "pk":
			if in.IsNull() {
				in.Skip()
				out.PK = nil
			} else {
				if out.PK == nil {
					out.PK = new(Columns)
				}
				if in.IsNull() {
					in.Skip()
					*out.PK = nil
				} else {
					in.Delim('[')
					if *out.PK == nil {
						if !in.IsDelim(']') {
							*out.PK = make(Columns, 0, 4)
						} else {
							*out.PK = Columns{}
						}
					} else {
						*out.PK = (*out.PK)[:0]
					}
					for !in.IsDelim(']') {
						var v3 string
						v3 = string(in.String())
						*out.PK = append(*out.PK, v3)
						in.WantComma()
					}
					in.Delim(']')
				}
			}
		case "commit_time":
			if data := in.Raw(); in.Ok() {
				in.AddError((out.CommitTime).UnmarshalJSON(data))
			}
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson4086215fEncodeGitlabComMiatelGoUtilsDatabaseCdc(out *jwriter.Writer, in Message) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"operation\":"
		out.RawString(prefix[1:])
		out.RawText((in.Operation).MarshalText())
	}
	{
		const prefix string = ",\"schema\":"
		out.RawString(prefix)
		out.String(string(in.Schema))
	}
	{
		const prefix string = ",\"table\":"
		out.RawString(prefix)
		out.String(string(in.Table))
	}
	if in.Before != nil {
		const prefix string = ",\"before\":"
		out.RawString(prefix)
		if *in.Before == nil && (out.Flags&jwriter.NilMapAsEmpty) == 0 {
			out.RawString(`null`)
		} else {
			out.RawByte('{')
			v4First := true
			for v4Name, v4Value := range *in.Before {
				if v4First {
					v4First = false
				} else {
					out.RawByte(',')
				}
				out.String(string(v4Name))
				out.RawByte(':')
				if m, ok := v4Value.(easyjson.Marshaler); ok {
					m.MarshalEasyJSON(out)
				} else if m, ok := v4Value.(json.Marshaler); ok {
					out.Raw(m.MarshalJSON())
				} else {
					out.Raw(json.Marshal(v4Value))
				}
			}
			out.RawByte('}')
		}
	}
	if in.After != nil {
		const prefix string = ",\"after\":"
		out.RawString(prefix)
		if *in.After == nil && (out.Flags&jwriter.NilMapAsEmpty) == 0 {
			out.RawString(`null`)
		} else {
			out.RawByte('{')
			v5First := true
			for v5Name, v5Value := range *in.After {
				if v5First {
					v5First = false
				} else {
					out.RawByte(',')
				}
				out.String(string(v5Name))
				out.RawByte(':')
				if m, ok := v5Value.(easyjson.Marshaler); ok {
					m.MarshalEasyJSON(out)
				} else if m, ok := v5Value.(json.Marshaler); ok {
					out.Raw(m.MarshalJSON())
				} else {
					out.Raw(json.Marshal(v5Value))
				}
			}
			out.RawByte('}')
		}
	}
	if in.PK != nil {
		const prefix string = ",\"pk\":"
		out.RawString(prefix)
		if *in.PK == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
			out.RawString("null")
		} else {
			out.RawByte('[')
			for v6, v7 := range *in.PK {
				if v6 > 0 {
					out.RawByte(',')
				}
				out.String(string(v7))
			}
			out.RawByte(']')
		}
	}
	{
		const prefix string = ",\"commit_time\":"
		out.RawString(prefix)
		out.Raw((in.CommitTime).MarshalJSON())
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v Message) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson4086215fEncodeGitlabComMiatelGoUtilsDatabaseCdc(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v Message) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson4086215fEncodeGitlabComMiatelGoUtilsDatabaseCdc(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *Message) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson4086215fDecodeGitlabComMiatelGoUtilsDatabaseCdc(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *Message) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson4086215fDecodeGitlabComMiatelGoUtilsDatabaseCdc(l, v)
}
